import t, c


# ==============================================
# SHA512 哈希算法
# ==============================================
SHA512_BLOCK_LEN:  t.CDefine = 128
SHA512_DIGEST_LEN: t.CDefine =  64

def sha512_ror(x: t.CUInt64T, n: int) -> t.CUInt64T: return (x >> n) | (x << (64 - n))
def sha512_shr(x: t.CUInt64T, n: int) -> t.CUInt64T: return x >> n
def sha512_Ch (x: t.CUInt64T, y: t.CUInt64T, z: t.CUInt64T) -> t.CUInt64T: return (x & y) ^ (~x & z)
def sha512_Maj(x: t.CUInt64T, y: t.CUInt64T, z: t.CUInt64T) -> t.CUInt64T: return (x & y) ^ (x & z) ^ (y & z)
def sha512_BigSigma0(x: t.CUInt64T) -> t.CUInt64T: return sha512_ror(x, 28) ^ sha512_ror(x, 34) ^ sha512_ror(x, 39)
def sha512_BigSigma1(x: t.CUInt64T) -> t.CUInt64T: return sha512_ror(x, 14) ^ sha512_ror(x, 18) ^ sha512_ror(x, 41)
def sha512_Sigma0(x: t.CUInt64T) -> t.CUInt64T:    return sha512_ror(x,  1) ^ sha512_ror(x,  8) ^ sha512_shr(x,  7)
def sha512_Sigma1(x: t.CUInt64T) -> t.CUInt64T:    return sha512_ror(x, 19) ^ sha512_ror(x, 61) ^ sha512_shr(x,  6)

sha512_K: t.CArray[t.CUInt64T, 80] = [
    0x428a2f98d728ae22, 0x7137449123ef65cd, 0xb5c0fbcfec4d3b2f, 0xe9b5dba58189dbbc,
    0x3956c25bf348b538, 0x59f111f1b605d019, 0x923f82a4af194f9b, 0xab1c5ed5da6d8118,
    0xd807aa98a3030242, 0x12835b0145706fbe, 0x243185be4ee4b28c, 0x550c7dc3d5ffb4e2,
    0x72be5d74f27b896f, 0x80deb1fe3b1696b1, 0x9bdc06a725c71235, 0xc19bf174cf692694,
    0xe49b69c19ef14ad2, 0xefbe4786384f25e3, 0x0fc19dc68b8cd5b5, 0x240ca1cc77ac9c65,
    0x2de92c6f592b0275, 0x4a7484aa6ea6e483, 0x5cb0a9dcbd41fbd4, 0x76f988da831153b5,
    0x983e5152ee66dfab, 0xa831c66d2db43210, 0xb00327c898fb213f, 0xbf597fc7beef0ee4,
    0xc6e00bf33da88fc2, 0xd5a79147930aa725, 0x06ca6351e003826f, 0x142929670a0e6e70,
    0x27b70a8546d22ffc, 0x2e1b21385c26c926, 0x4d2c6dfc5ac42aed, 0x53380d139d95b3df,
    0x650a73548baf63de, 0x766a0abb3c77b2a8, 0x81c2c92e47edaee6, 0x92722c851482353b,
    0xa2bfe8a14cf10364, 0xa81a664bbc423001, 0xc24b8b70d0f89791, 0xc76c51a30654be30,
    0xd192e819d6ef5218, 0xd69906245565a910, 0xf40e35855771202a, 0x106aa07032bbd1b8,
    0x19a4c116b8d2d0c8, 0x1e376c085141ab53, 0x2748774cdf8eeb99, 0x34b0bcb5e19b48a8,
    0x391c0cb3c5c95a63, 0x4ed8aa4ae3418acb, 0x5b9cca4f7763e373, 0x682e6ff3d6b2b8a3,
    0x748f82ee5defb2fc, 0x78a5636f43172f60, 0x84c87814a1f0ab72, 0x8cc702081a6439ec,
    0x90befffa23631e28, 0xa4506cebde82bde9, 0xbef9a3f7b2c67915, 0xc67178f2e372532b,
    0xca273eceea26619c, 0xd186b8c721c0c207, 0xeada7dd6cde0eb1e, 0xf57d4f7fee6ed178,
    0x06f067aa72176fba, 0x0a637dc5a2c898a6, 0x113f9804bef90dae, 0x1b710b35131c471b,
    0x28db77f523047d84, 0x32caab7b40c72493, 0x3c9ebe0a15c9bebc, 0x431d67c49c100d4c,
    0x4cc5d4becb3e42b6, 0x597f299cfc657e2a, 0x5fcb6fab3ad6faec, 0x6c44198c4a475817
]

@t.Object
class sha512:
    state: t.CArray[t.CUInt64T, 8]
    count: t.CArray[t.CUInt64T, 2]
    buf:   t.CArray[t.CUInt8T, SHA512_BLOCK_LEN]
    def __init__(self):
        memset(self, 0, sha512.__sizeof__())
        self.state[0] = 0x6a09e667f3bcc908
        self.state[1] = 0xbb67ae8584caa73b
        self.state[2] = 0x3c6ef372fe94f82b
        self.state[3] = 0xa54ff53a5f1d36f1
        self.state[4] = 0x510e527fade682d1
        self.state[5] = 0x9b05688c2b3e6c1f
        self.state[6] = 0x1f83d9abfb41bd6b
        self.state[7] = 0x5be0cd19137e2179
    def transform(self, block: t.CArray[t.CUInt8T, SHA512_BLOCK_LEN]):
        w: t.CArray[t.CUInt64T, 80]
        a: t.CUInt64T
        b: t.CUInt64T
        c: t.CUInt64T
        d: t.CUInt64T
        e: t.CUInt64T
        f: t.CUInt64T
        g: t.CUInt64T
        h: t.CUInt64T
        t1: t.CUInt64T
        t2: t.CUInt64T
        for i in range(16):
            w[i]  = t.CUInt64T(block[i * 8 + 0]) << 56
            w[i] |= t.CUInt64T(block[i * 8 + 1]) << 48
            w[i] |= t.CUInt64T(block[i * 8 + 2]) << 40
            w[i] |= t.CUInt64T(block[i * 8 + 3]) << 32
            w[i] |= t.CUInt64T(block[i * 8 + 4]) << 24
            w[i] |= t.CUInt64T(block[i * 8 + 5]) << 16
            w[i] |= t.CUInt64T(block[i * 8 + 6]) <<  8
            w[i] |= t.CUInt64T(block[i * 8 + 7]) <<  0
        for i in range(16, 80):
            w[i] = sha512_Sigma1(w[i-2]) + w[i-7] + sha512_Sigma0(w[i-15]) + w[i-16]
        a = self.state[0]
        b = self.state[1]
        c = self.state[2]
        d = self.state[3]
        e = self.state[4]
        f = self.state[5]
        g = self.state[6]
        h = self.state[7]
        for i in range(80):
            t1 = h + sha512_BigSigma1(e) + sha512_Ch(e, f, g) + sha512_K[i] + w[i]
            t2 = sha512_BigSigma0(a) + sha512_Maj(a, b, c)
            h = g; g = f; f = e
            e = d + t1
            d = c; c = b; b = a
            a = t1 + t2
        self.state[0] += a
        self.state[1] += b
        self.state[2] += c
        self.state[3] += d
        self.state[4] += e
        self.state[5] += f
        self.state[6] += g
        self.state[7] += h
    def update(self, s: str):
        data: t.CUInt8T | t.CPtr = t.CUInt8T(s, t.CPtr)
        length: t.CSizeT = len(s)
        idx: t.CUInt32T = t.CUInt32T(self.count[0] % SHA512_BLOCK_LEN)
        self.count[0] += length
        if self.count[0] < length:
            self.count[1] += 1
        if idx > 0:
            left: t.CSizeT = SHA512_BLOCK_LEN - idx
            if length >= left:
                memcpy(self.buf + idx, data, left)
                self.transform(self.buf)
                data += left
                length -= left
                idx = 0
        while length >= SHA512_BLOCK_LEN:
            self.transform(data)
            data += SHA512_BLOCK_LEN
            length -= SHA512_BLOCK_LEN
        if length > 0:
            memcpy(self.buf + idx, data, length)
    def final(self, out: t.CArray[t.CUInt8T, SHA512_DIGEST_LEN]):
        bits_lo: t.CUInt64T = self.count[0] << 3
        bits_hi: t.CUInt64T = (self.count[1] << 3) | (self.count[0] >> 61)
        idx: t.CUInt32T = t.CUInt32T(self.count[0] % SHA512_BLOCK_LEN)
        self.buf[idx] = 0x80
        idx += 1
        if idx > SHA512_BLOCK_LEN - 16:
            memset(self.buf + idx, 0, SHA512_BLOCK_LEN - idx)
            self.transform(self.buf)
            idx = 0
        memset(self.buf + idx, 0, SHA512_BLOCK_LEN - 16 - idx)
        for i in range(8):
            self.buf[SHA512_BLOCK_LEN - 16 + i] = t.CUInt8T(bits_hi >> (56 - i * 8))
        for i in range(8):
            self.buf[SHA512_BLOCK_LEN - 8 + i] = t.CUInt8T(bits_lo >> (56 - i * 8))
        self.transform(self.buf)
        for i in range(8):
            out[i * 8 + 0] = t.CUInt8T(self.state[i] >> 56)
            out[i * 8 + 1] = t.CUInt8T(self.state[i] >> 48)
            out[i * 8 + 2] = t.CUInt8T(self.state[i] >> 40)
            out[i * 8 + 3] = t.CUInt8T(self.state[i] >> 32)
            out[i * 8 + 4] = t.CUInt8T(self.state[i] >> 24)
            out[i * 8 + 5] = t.CUInt8T(self.state[i] >> 16)
            out[i * 8 + 6] = t.CUInt8T(self.state[i] >>  8)
            out[i * 8 + 7] = t.CUInt8T(self.state[i] >>  0)
